package hdm.mi.growbros.controllers;

import hdm.mi.growbros.models.plant.Plant;
import hdm.mi.growbros.service.PlantsService;
import jakarta.validation.Valid;
import lombok.RequiredArgsConstructor;
import org.springframework.web.bind.annotation.*;

import java.util.Collection;

@RestController
@CrossOrigin
@RequiredArgsConstructor
public class PlantsController {
    private final PlantsService plantsService;

    @GetMapping("/api/v1/plants")
    public Collection<Plant> getAllPlants(
            @RequestParam(value = "page", defaultValue = "0") int page,
            @RequestParam(value = "pageSize", defaultValue = "25") int pageSize
    ) {
        return plantsService.getPlants(page, pageSize);
    }

    @GetMapping("api/v1/randomPlants/{numberOfPlants}")
    public Collection<Plant> getRandomPlants(@PathVariable Integer numberOfPlants) {return plantsService.getRandomPlants(numberOfPlants);}

    @PostMapping("/api/v1/plants")
    public void createPlant(@RequestBody @Valid Plant plant) {
        plantsService.createPlant(plant);
    }
}
